#include <token.h>

const char* OP_LIST[] = {
    [OP_ADD]  = "add",
    [OP_SUB]  = "sub",
    [OP_MUL]  = "mul",
    [OP_DIV]  = "div",
    [OP_MOD]  = "mod",
    [OP_EQ]   = "eq",
    [OP_GT]   = "gt",
    [OP_LT]   = "lt",
    [OP_GE]   = "ge",
    [OP_LE]   = "le",
    [OP_NE]   = "ne",
    [OP_SHR]  = "shr",
    [OP_SHL]  = "shl",
    [OP_OR]   = "or",
    [OP_AND]  = "and",
    [OP_NOT]  = "not",
    [OP_DUP]  = "dup",
    [OP_SWAP] = "swap",
    [OP_DROP] = "drop",
    [OP_OVER] = "over",
    [OP_ROT]  = "rot",
    [OP_LOAD8]    = "load8",
    [OP_STORE8]   = "store8",
    [OP_LOAD16]   = "load16",
    [OP_STORE16]  = "store16",
    [OP_LOAD32]   = "load32",
    [OP_STORE32]  = "store32",
    [OP_LOAD64]   = "load64",
    [OP_STORE64]  = "store64",
    [OP_SYSCALL0] = "syscall0",
    [OP_SYSCALL1] = "syscall1",
    [OP_SYSCALL2] = "syscall2",
    [OP_SYSCALL3] = "syscall3",
    [OP_SYSCALL4] = "syscall4",
    [OP_SYSCALL5] = "syscall5",
    [OP_SYSCALL6] = "syscall6",
    [OP_ARGC]     = "__argv__",
    [OP_ARGV]     = "__argv__",
    [OP_CAST_PTR] = "cast(ptr)",
    [OP_CAST_INT] = "cast(int)",
    [OP_CAST_BOOL] = "cast(bool)",
    [OP_HERE]     = "__here__",
    [OP_PRINT]    = "__print__" 
};
const char* KW_LIST[] = {
    [KW_FN] = "fn",
    [KW_DO] = "do",
    [KW_END] = "end",
    [KW_WITH] = "with",
    [KW_RETURNS] = "returns",
    [KW_STRUCT] = "struct",
    [KW_ENUM] = "enum",
    [KW_IF] = "if",
    [KW_ELSE] = "else",
    [KW_WHILE] = "while",
    [KW_CONST] = "const",
    [KW_MEMORY] = "memory"
};
